#define _CRT_SECURE_NO_WARNINGS
#define _SILENCE_CXX17_C_HEADER_DEPRECATION_WARNING
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/hash_policy.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
#define CRP(t, x) const t &x
#define OPX(op, t, x) operator op(CRP(t, x))
#define OPL(t, x) bool OPX(<, t, x) const
#define FIL(x, v) memset(x, v, sizeof(x))
#define CLR(x) FIL(x, 0)
#define NE1(x) FIL(x, -1)
#define INF(x) FIL(x, 0x3f)
#ifndef _DEBUG
#define _DEBUG 0
#endif // !_DEBUG
#define IFD if (_DEBUG)
typedef int64_t ll, i64;
typedef uint64_t ull, u64;
template <typename T>
using enable_if_arithmetic = typename enable_if<is_arithmetic<T>::value>::type;
template <typename T>
using enable_if_integral = typename enable_if<is_integral<T>::value>::type;
inline char getchar(int)
{
    static char buf[64 << 20], *S = buf, *T = buf;
    if (S == T) T = fread(S = buf, 1, 64 << 20, stdin) + S;
    return S == T ? EOF : *S++;
}
template <typename T, typename = enable_if_integral<T>>
inline void read(T &x)
{
    int ch = x = 0, f = 1;
    while (!isdigit(ch = getchar()))
        if (ch == '-') f = -1;
    for (; isdigit(ch); ch = getchar()) x = x * 10 + ch - '0';
    x *= f;
}
template <typename T, typename... Args, typename = enable_if_integral<T>>
inline void read(T &x, Args &... args) { read(x), read(args...); }
ll gcd(ll a, ll b) { return b == 0 ? a : gcd(b, a % b); }
ll fpow(ll a, ll b, ll m)
{
    ll r = 1;
    for (; b; b >>= 1, a = a * a % m)
        if (b & 1) r = r * a % m;
    return r;
}
constexpr double eps = 1e-8;
inline int sgn(double x) { return x > eps ? 1 : x < -eps ? -1 : 0; }
const int N = 1e6 + 50;
//__gnu_pbds::gp_hash_table<ll, ll> mps[N];
//map<ll, ll> mps[N];
//__gnu_pbds::tree<ll, ll, less<ll>, __gnu_pbds::ov_tree_tag> mps[N];
vector<ll> mps[N];
pair<ll, ll> ch[N];
ll cnt[N];
int ops[N];
int main()
{
    int T, n, op;
    read(T);
    while (T--)
    {
        read(n);
        for (int i = 1; i <= n; i++)
        {
            auto &&curMap = mps[i];
            cnt[i] = 0;
            read(op);
            ops[i] = op;
            if (op == 1)
            {
                curMap.clear();
                int k, x;
                read(k);
                while (k--) read(x), curMap.push_back(x);
            }
            if (op == 2)
            {
                int x, y;
                read(x, y);
                ch[i] = {x, y};
            }
        }
        cnt[n] = 1;
        for (int i = n; i; i--)
            if (ops[i] == 2) cnt[ch[i].first] += cnt[i], cnt[ch[i].second] += cnt[i];
        /*map<ll, ll> endMap;
        for (int i = n; i; i--)
            if (ops[i] == 1)
                for (auto &&p : mps[i])
                    endMap[p] += cnt[i];
        pair<ll, ll> mx = {0, 0};
        ll len = 0, ans = 0;
        for (auto &&p : endMap) mx = max(mx, {p.second, p.first}), len += p.second;*/
        ll mx = 0, mxcnt = 0, len = 0;
        for (int i = 1; i <= n; i++)
            if (ops[i] == 1 && cnt[i])
                for (auto j : mps[i])
                {
                    if (mx == 0)
                        mx = j, mxcnt += cnt[i];
                    else if (mx == j)
                        mxcnt += cnt[i];
                    else
                    {
                        if (cnt[i] > mxcnt)
                            mx = j, mxcnt = cnt[i] - mxcnt;
                        else
                            mxcnt -= cnt[i];
                    }
                    len += cnt[i];
                }
        ll tot = 0;
        for (int i = 1; i <= n; i++)
            if (ops[i] == 1 && cnt[i])
                for (auto j : mps[i])
                    if (j == mx) tot += cnt[i];
        printf("%lld\n", (tot << 1) <= len ? len : (len - tot) << 1);
    }
    return 0;
}